/*************************************************
* Aliases List Source File                       *
* (C) 1999-2002 The Botan Project                *
*************************************************/

#include <botan/look_add.h>

namespace Botan {

/*************************************************
* Load the algorithms list                       *
*************************************************/
void setup_aliases()
   {
   add_alias("AES", "Rijndael");
   add_alias("CAST5", "CAST-128");
   add_alias("SHA1", "SHA-1");
   add_alias("LubyRackoff", "Luby-Rackoff");

   // DEPRECATED ALIASES
   add_alias("HAVAL-128", "HAVAL(16)");
   add_alias("HAVAL-160", "HAVAL(20)");
   add_alias("HAVAL-192", "HAVAL(24)");
   add_alias("HAVAL-224", "HAVAL(28)");
   add_alias("HAVAL-256", "HAVAL(32)");
   // END DEPRECATED ALIASES

   add_alias("EMSA-PKCS1-v1_5", "EMSA3");
   add_alias("EME-PKCS1-v1_5", "PKCS1v15");

   add_alias("OpenPGP.Cipher.1", "IDEA");
   add_alias("OpenPGP.Cipher.2", "TripleDES");
   add_alias("OpenPGP.Cipher.3", "CAST-128");
   add_alias("OpenPGP.Cipher.4", "Blowfish");
   add_alias("OpenPGP.Cipher.5", "SAFER-SK(13)");
   add_alias("OpenPGP.Cipher.7", "AES");
   add_alias("OpenPGP.Cipher.8", "AES");
   add_alias("OpenPGP.Cipher.9", "AES");

   add_alias("OpenPGP.Digest.1", "MD5");
   add_alias("OpenPGP.Digest.2", "SHA-1");
   add_alias("OpenPGP.Digest.3", "RIPEMD-160");
   add_alias("OpenPGP.Digest.5", "MD2");
   add_alias("OpenPGP.Digest.6", "Tiger");
   add_alias("OpenPGP.Digest.7", "HAVAL(20)");
   }

}
