/*************************************************
* KDF1 Source File                               *
* (C) 1999-2002 The Botan Project                *
*************************************************/

#include <botan/kdf1.h>
#include <botan/lookup.h>

namespace Botan {

/*************************************************
* KDF1 Key Derivation Mechanism                  *
*************************************************/
SymmetricKey KDF1::derive(const byte in[], u32bit length, u32bit) const
   {
   hash->update(in, length);
   hash->update(P);
   return SymmetricKey(hash->final());
   }

/*************************************************
* KDF1 Constructor                               *
*************************************************/
KDF1::KDF1(const std::string& hash_name, const std::string& Pstr) : P(Pstr)
   {
   hash = get_hash(hash_name);
   }

}
