/*************************************************
* Modular Reducer Source File                    *
* (C) 1999-2002 The Botan Project                *
*************************************************/

#include <botan/reducer.h>

namespace Botan {

/*************************************************
* Construct a ModularReducer                     *
*************************************************/
ModularReducer::ModularReducer(const BigInt& n) : modulus(n)
   {
   if(modulus < 0)
      throw Invalid_Argument("ModularReducer: modulus must be positive");
   }

/*************************************************
* Modular Multiplication                         *
*************************************************/
BigInt ModularReducer::multiply(const BigInt& a, const BigInt& b) const
   {
   return reduce(a * b);
   }

/*************************************************
* Modular Squaring                               *
*************************************************/
BigInt ModularReducer::square(const BigInt& a) const
   {
   return reduce(a * a);
   }

}
